<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Moxit: MoxitServer Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Moxit
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="#pri-static-attribs">Static Private Attributes</a> &#124;
<a href="classMoxitServer-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">MoxitServer Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="moxit__server_8h_source.html">moxit_server.h</a>&gt;</code></p>
<div class="dynheader">
Collaboration diagram for MoxitServer:</div>
<div class="dyncontent">
<div class="center"><img src="classMoxitServer__coll__graph.png" border="0" usemap="#MoxitServer_coll__map" alt="Collaboration graph"/></div>
<map name="MoxitServer_coll__map" id="MoxitServer_coll__map">
<area shape="rect" title=" " alt="" coords="5,5,199,537"/>
</map>
</div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a6656c3b00da6d383a3382d0beb0ed41b"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a6656c3b00da6d383a3382d0beb0ed41b">MoxitServer</a> (std::string ip_address, int port)</td></tr>
<tr class="separator:a6656c3b00da6d383a3382d0beb0ed41b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a473ad2a88e8a75277320d0798b87b29e"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a473ad2a88e8a75277320d0798b87b29e">~MoxitServer</a> ()</td></tr>
<tr class="separator:a473ad2a88e8a75277320d0798b87b29e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a536eacacba0de2cec5c54fef1b6490cf"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a536eacacba0de2cec5c54fef1b6490cf">startListen</a> ()</td></tr>
<tr class="separator:a536eacacba0de2cec5c54fef1b6490cf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7810af2b4e6f9703f039f6ff5c3cef8d"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classMoxitServer.html">MoxitServer</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a7810af2b4e6f9703f039f6ff5c3cef8d">post</a> (const std::string &amp;path, const <a class="el" href="handler_8h.html#a90dff9b74e811490ae5849a46c222587">HandlerType</a> &amp;handler)</td></tr>
<tr class="separator:a7810af2b4e6f9703f039f6ff5c3cef8d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa435ab97288dd6a4997d59b304b91581"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classMoxitServer.html">MoxitServer</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#aa435ab97288dd6a4997d59b304b91581">use</a> (<a class="el" href="request__header_8h.html#a2a3c0067e44c5ef3210a256d06c16b0f">Method</a> method, const std::string &amp;path, const <a class="el" href="handler_8h.html#a90dff9b74e811490ae5849a46c222587">HandlerType</a> &amp;handler)</td></tr>
<tr class="separator:aa435ab97288dd6a4997d59b304b91581"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:ae113d589a464cf3322f208e27c991ed6"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#ae113d589a464cf3322f208e27c991ed6">startServer</a> ()</td></tr>
<tr class="separator:ae113d589a464cf3322f208e27c991ed6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1cf829394a93cb21c1f51b0bc83ab534"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a1cf829394a93cb21c1f51b0bc83ab534">closeServer</a> ()</td></tr>
<tr class="separator:a1cf829394a93cb21c1f51b0bc83ab534"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0e4d00dacf1fddd87bb2bd2e93c7f979"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a0e4d00dacf1fddd87bb2bd2e93c7f979">acceptConnection</a> ()</td></tr>
<tr class="separator:a0e4d00dacf1fddd87bb2bd2e93c7f979"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a20e0cc1f5bec89daf4a7ff46d13c41eb"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a20e0cc1f5bec89daf4a7ff46d13c41eb">processConnection</a> (int socket, <a class="el" href="structHttpStatus.html">HttpStatus</a> *httpStatus) const</td></tr>
<tr class="separator:a20e0cc1f5bec89daf4a7ff46d13c41eb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aed8d069006c7ec1f448f1825d76fd1dc"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#aed8d069006c7ec1f448f1825d76fd1dc">setUpEpoll</a> ()</td></tr>
<tr class="separator:aed8d069006c7ec1f448f1825d76fd1dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0ad33e0e6d0d824823dadaaf758ae498"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a0ad33e0e6d0d824823dadaaf758ae498">configureEpoll</a> (int socket, epoll_event *event=nullptr)</td></tr>
<tr class="separator:a0ad33e0e6d0d824823dadaaf758ae498"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7000acb21bf5fb4ae7e62473697382bd"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a7000acb21bf5fb4ae7e62473697382bd">addEpollWriteEvent</a> (const <a class="el" href="classRequest.html">Request</a> &amp;request, const std::string &amp;response)</td></tr>
<tr class="separator:a7000acb21bf5fb4ae7e62473697382bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af62885cc6e61a4e339daccdd1b13c1d8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#af62885cc6e61a4e339daccdd1b13c1d8">startWorkerThread</a> ()</td></tr>
<tr class="separator:af62885cc6e61a4e339daccdd1b13c1d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0e3a012b7cdb32afda6ca56e017e90be"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a0e3a012b7cdb32afda6ca56e017e90be">readFromClient</a> (int client, <a class="el" href="structHttpStatus.html">HttpStatus</a> *httpStatus)</td></tr>
<tr class="separator:a0e3a012b7cdb32afda6ca56e017e90be"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aec4a32749b763ec6ecdcd6de49768d2e"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#aec4a32749b763ec6ecdcd6de49768d2e">writeToClient</a> (<a class="el" href="structHttpStatus.html">HttpStatus</a> *httpStatus)</td></tr>
<tr class="separator:aec4a32749b763ec6ecdcd6de49768d2e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6db04833cb6adf5c54c17005d73bec53"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a6db04833cb6adf5c54c17005d73bec53">addHandlers</a> ()</td></tr>
<tr class="separator:a6db04833cb6adf5c54c17005d73bec53"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:aeadf910ac6b5cd14f1690d9b9d8bcbce"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#aeadf910ac6b5cd14f1690d9b9d8bcbce">m_ip_address</a></td></tr>
<tr class="separator:aeadf910ac6b5cd14f1690d9b9d8bcbce"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a666ed13291b3437b4edc69862c40ebea"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a666ed13291b3437b4edc69862c40ebea">m_port</a></td></tr>
<tr class="separator:a666ed13291b3437b4edc69862c40ebea"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab4b11b84d055e1a330240be3504cc465"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#ab4b11b84d055e1a330240be3504cc465">m_socket</a></td></tr>
<tr class="separator:ab4b11b84d055e1a330240be3504cc465"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac76fc67d56504bea0f4e2b9af1a93c49"><td class="memItemLeft" align="right" valign="top">std::unordered_map&lt; std::string, <a class="el" href="classGame.html">Game</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#ac76fc67d56504bea0f4e2b9af1a93c49">m_games</a></td></tr>
<tr class="separator:ac76fc67d56504bea0f4e2b9af1a93c49"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a04311593233a95734a7a5ebbff08b07c"><td class="memItemLeft" align="right" valign="top">std::unordered_map&lt; std::string, int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a04311593233a95734a7a5ebbff08b07c">m_gameStateSockets</a></td></tr>
<tr class="separator:a04311593233a95734a7a5ebbff08b07c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aab66542e70f820212b452e081c61e224"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#aab66542e70f820212b452e081c61e224">createdGameCounter</a></td></tr>
<tr class="separator:aab66542e70f820212b452e081c61e224"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9f703c913fed1ff7c92587868d7d2ced"><td class="memItemLeft" align="right" valign="top">struct sockaddr_in&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a9f703c913fed1ff7c92587868d7d2ced">m_socketAddress</a></td></tr>
<tr class="separator:a9f703c913fed1ff7c92587868d7d2ced"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa8aba33a384400ac9368eb64ad84da17"><td class="memItemLeft" align="right" valign="top">unsigned&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#aa8aba33a384400ac9368eb64ad84da17">m_socketAddress_length</a></td></tr>
<tr class="separator:aa8aba33a384400ac9368eb64ad84da17"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aad28f72d540a777bd6bd2e28f19743f0"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#aad28f72d540a777bd6bd2e28f19743f0">m_running</a></td></tr>
<tr class="separator:aad28f72d540a777bd6bd2e28f19743f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7cd3b8f962bc132586ab629e0e3c24a6"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a7cd3b8f962bc132586ab629e0e3c24a6">m_epfd</a></td></tr>
<tr class="separator:a7cd3b8f962bc132586ab629e0e3c24a6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a76af6d8d08643683f608e15cb00c2fc4"><td class="memItemLeft" align="right" valign="top">struct epoll_event&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a76af6d8d08643683f608e15cb00c2fc4">m_evlist</a> [1024]</td></tr>
<tr class="separator:a76af6d8d08643683f608e15cb00c2fc4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a99eb797e882eccfd4c7e354e6bd13c1b"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a99eb797e882eccfd4c7e354e6bd13c1b">m_numOfClients</a></td></tr>
<tr class="separator:a99eb797e882eccfd4c7e354e6bd13c1b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a14c168e115aca57dc9cd0f818b470201"><td class="memItemLeft" align="right" valign="top">std::vector&lt; int &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a14c168e115aca57dc9cd0f818b470201">m_clientSocketFds</a></td></tr>
<tr class="separator:a14c168e115aca57dc9cd0f818b470201"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad0dc6effca9577805c18bb5d09de73e4"><td class="memItemLeft" align="right" valign="top">std::vector&lt; std::thread &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#ad0dc6effca9577805c18bb5d09de73e4">m_worker_threads</a></td></tr>
<tr class="separator:ad0dc6effca9577805c18bb5d09de73e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:accd4e8d13caef3f398c2bb8db150bd4c"><td class="memItemLeft" align="right" valign="top">std::vector&lt; <a class="el" href="classHandler.html">Handler</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#accd4e8d13caef3f398c2bb8db150bd4c">m_handlers</a></td></tr>
<tr class="separator:accd4e8d13caef3f398c2bb8db150bd4c"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-static-attribs"></a>
Static Private Attributes</h2></td></tr>
<tr class="memitem:ac524f1c5355989b7d8cdc61092ff3263"><td class="memItemLeft" align="right" valign="top">static constexpr int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#ac524f1c5355989b7d8cdc61092ff3263">k_backlogSize</a> = 1024</td></tr>
<tr class="separator:ac524f1c5355989b7d8cdc61092ff3263"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0030e56429f7047ba6e1f5c27e8b95f4"><td class="memItemLeft" align="right" valign="top">static constexpr int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classMoxitServer.html#a0030e56429f7047ba6e1f5c27e8b95f4">k_threadPoolSize</a> = 3</td></tr>
<tr class="separator:a0030e56429f7047ba6e1f5c27e8b95f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a6656c3b00da6d383a3382d0beb0ed41b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6656c3b00da6d383a3382d0beb0ed41b">&#9670;&nbsp;</a></span>MoxitServer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">MoxitServer::MoxitServer </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>ip_address</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>port</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a473ad2a88e8a75277320d0798b87b29e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a473ad2a88e8a75277320d0798b87b29e">&#9670;&nbsp;</a></span>~MoxitServer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">MoxitServer::~MoxitServer </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a0e4d00dacf1fddd87bb2bd2e93c7f979"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0e4d00dacf1fddd87bb2bd2e93c7f979">&#9670;&nbsp;</a></span>acceptConnection()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int MoxitServer::acceptConnection </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a7000acb21bf5fb4ae7e62473697382bd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7000acb21bf5fb4ae7e62473697382bd">&#9670;&nbsp;</a></span>addEpollWriteEvent()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void MoxitServer::addEpollWriteEvent </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classRequest.html">Request</a> &amp;&#160;</td>
          <td class="paramname"><em>request</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>response</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a6db04833cb6adf5c54c17005d73bec53"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6db04833cb6adf5c54c17005d73bec53">&#9670;&nbsp;</a></span>addHandlers()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void MoxitServer::addHandlers </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a1cf829394a93cb21c1f51b0bc83ab534"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1cf829394a93cb21c1f51b0bc83ab534">&#9670;&nbsp;</a></span>closeServer()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void MoxitServer::closeServer </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a0ad33e0e6d0d824823dadaaf758ae498"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0ad33e0e6d0d824823dadaaf758ae498">&#9670;&nbsp;</a></span>configureEpoll()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void MoxitServer::configureEpoll </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>socket</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">epoll_event *&#160;</td>
          <td class="paramname"><em>event</em> = <code>nullptr</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a7810af2b4e6f9703f039f6ff5c3cef8d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7810af2b4e6f9703f039f6ff5c3cef8d">&#9670;&nbsp;</a></span>post()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classMoxitServer.html">MoxitServer</a> &amp; MoxitServer::post </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>path</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="handler_8h.html#a90dff9b74e811490ae5849a46c222587">HandlerType</a> &amp;&#160;</td>
          <td class="paramname"><em>handler</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a20e0cc1f5bec89daf4a7ff46d13c41eb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a20e0cc1f5bec89daf4a7ff46d13c41eb">&#9670;&nbsp;</a></span>processConnection()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void MoxitServer::processConnection </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>socket</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structHttpStatus.html">HttpStatus</a> *&#160;</td>
          <td class="paramname"><em>httpStatus</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a0e3a012b7cdb32afda6ca56e017e90be"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0e3a012b7cdb32afda6ca56e017e90be">&#9670;&nbsp;</a></span>readFromClient()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int MoxitServer::readFromClient </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>client</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="structHttpStatus.html">HttpStatus</a> *&#160;</td>
          <td class="paramname"><em>httpStatus</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="aed8d069006c7ec1f448f1825d76fd1dc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aed8d069006c7ec1f448f1825d76fd1dc">&#9670;&nbsp;</a></span>setUpEpoll()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void MoxitServer::setUpEpoll </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a536eacacba0de2cec5c54fef1b6490cf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a536eacacba0de2cec5c54fef1b6490cf">&#9670;&nbsp;</a></span>startListen()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void MoxitServer::startListen </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="ae113d589a464cf3322f208e27c991ed6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae113d589a464cf3322f208e27c991ed6">&#9670;&nbsp;</a></span>startServer()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int MoxitServer::startServer </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="af62885cc6e61a4e339daccdd1b13c1d8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af62885cc6e61a4e339daccdd1b13c1d8">&#9670;&nbsp;</a></span>startWorkerThread()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void MoxitServer::startWorkerThread </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="aa435ab97288dd6a4997d59b304b91581"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa435ab97288dd6a4997d59b304b91581">&#9670;&nbsp;</a></span>use()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classMoxitServer.html">MoxitServer</a> &amp; MoxitServer::use </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="request__header_8h.html#a2a3c0067e44c5ef3210a256d06c16b0f">Method</a>&#160;</td>
          <td class="paramname"><em>method</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>path</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="handler_8h.html#a90dff9b74e811490ae5849a46c222587">HandlerType</a> &amp;&#160;</td>
          <td class="paramname"><em>handler</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="aec4a32749b763ec6ecdcd6de49768d2e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aec4a32749b763ec6ecdcd6de49768d2e">&#9670;&nbsp;</a></span>writeToClient()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool MoxitServer::writeToClient </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structHttpStatus.html">HttpStatus</a> *&#160;</td>
          <td class="paramname"><em>httpStatus</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="aab66542e70f820212b452e081c61e224"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aab66542e70f820212b452e081c61e224">&#9670;&nbsp;</a></span>createdGameCounter</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned MoxitServer::createdGameCounter</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ac524f1c5355989b7d8cdc61092ff3263"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac524f1c5355989b7d8cdc61092ff3263">&#9670;&nbsp;</a></span>k_backlogSize</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">constexpr int MoxitServer::k_backlogSize = 1024</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span><span class="mlabel">constexpr</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a0030e56429f7047ba6e1f5c27e8b95f4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0030e56429f7047ba6e1f5c27e8b95f4">&#9670;&nbsp;</a></span>k_threadPoolSize</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">constexpr int MoxitServer::k_threadPoolSize = 3</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span><span class="mlabel">constexpr</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a14c168e115aca57dc9cd0f818b470201"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a14c168e115aca57dc9cd0f818b470201">&#9670;&nbsp;</a></span>m_clientSocketFds</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;int&gt; MoxitServer::m_clientSocketFds</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a7cd3b8f962bc132586ab629e0e3c24a6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7cd3b8f962bc132586ab629e0e3c24a6">&#9670;&nbsp;</a></span>m_epfd</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int MoxitServer::m_epfd</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a76af6d8d08643683f608e15cb00c2fc4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a76af6d8d08643683f608e15cb00c2fc4">&#9670;&nbsp;</a></span>m_evlist</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">struct epoll_event MoxitServer::m_evlist[1024]</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ac76fc67d56504bea0f4e2b9af1a93c49"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac76fc67d56504bea0f4e2b9af1a93c49">&#9670;&nbsp;</a></span>m_games</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unordered_map&lt;std::string, <a class="el" href="classGame.html">Game</a>&gt; MoxitServer::m_games</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a04311593233a95734a7a5ebbff08b07c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a04311593233a95734a7a5ebbff08b07c">&#9670;&nbsp;</a></span>m_gameStateSockets</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unordered_map&lt;std::string, int&gt; MoxitServer::m_gameStateSockets</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="accd4e8d13caef3f398c2bb8db150bd4c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#accd4e8d13caef3f398c2bb8db150bd4c">&#9670;&nbsp;</a></span>m_handlers</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;<a class="el" href="classHandler.html">Handler</a>&gt; MoxitServer::m_handlers</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="aeadf910ac6b5cd14f1690d9b9d8bcbce"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aeadf910ac6b5cd14f1690d9b9d8bcbce">&#9670;&nbsp;</a></span>m_ip_address</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::string MoxitServer::m_ip_address</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a99eb797e882eccfd4c7e354e6bd13c1b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a99eb797e882eccfd4c7e354e6bd13c1b">&#9670;&nbsp;</a></span>m_numOfClients</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int MoxitServer::m_numOfClients</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a666ed13291b3437b4edc69862c40ebea"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a666ed13291b3437b4edc69862c40ebea">&#9670;&nbsp;</a></span>m_port</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int MoxitServer::m_port</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="aad28f72d540a777bd6bd2e28f19743f0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aad28f72d540a777bd6bd2e28f19743f0">&#9670;&nbsp;</a></span>m_running</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool MoxitServer::m_running</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ab4b11b84d055e1a330240be3504cc465"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab4b11b84d055e1a330240be3504cc465">&#9670;&nbsp;</a></span>m_socket</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int MoxitServer::m_socket</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a9f703c913fed1ff7c92587868d7d2ced"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9f703c913fed1ff7c92587868d7d2ced">&#9670;&nbsp;</a></span>m_socketAddress</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">struct sockaddr_in MoxitServer::m_socketAddress</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="aa8aba33a384400ac9368eb64ad84da17"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa8aba33a384400ac9368eb64ad84da17">&#9670;&nbsp;</a></span>m_socketAddress_length</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">unsigned MoxitServer::m_socketAddress_length</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="ad0dc6effca9577805c18bb5d09de73e4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad0dc6effca9577805c18bb5d09de73e4">&#9670;&nbsp;</a></span>m_worker_threads</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::vector&lt;std::thread&gt; MoxitServer::m_worker_threads</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>backend/src/lib/server/<a class="el" href="moxit__server_8h_source.html">moxit_server.h</a></li>
<li>backend/src/lib/server/<a class="el" href="moxit__server_8cpp.html">moxit_server.cpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
